/* ----------------------------------------------------------------------- */
/*  MathLib.h : interface of the mathematics library                       */
/*  Author : Ji HongKai ; Time: 2004.07                                    */
/* ----------------------------------------------------------------------- */

/* ----------------------------------------------------------------------- */
/*                              Declaration                                */
/* ----------------------------------------------------------------------- */

/* ----------------------------------------------------------------------- */ 
/*                                 Struct                                  */
/* ----------------------------------------------------------------------- */ 

/* ----------------------------------------------------------------------- */
/*                            lnGamma Function                             */
/* Return ln(gamma(dx)).                                                   */
/* ----------------------------------------------------------------------- */
double gammaln(double dx);

/* ----------------------------------------------------------------------- */
/*                              Gamma Function                             */
/* Return gamma(dx).                                                       */
/* ----------------------------------------------------------------------- */
double gamma(double dx);

/* ----------------------------------------------------------------------- */
/*                           Factorial Function                            */
/* Return nx! = 1*2*...*nx.                                                */
/* ----------------------------------------------------------------------- */
double factorial(int nx);

/* ----------------------------------------------------------------------- */
/*                               Beta Function                             */
/* Return beta(dx).                                                        */
/* ----------------------------------------------------------------------- */
double beta(double da, double db);

/* ----------------------------------------------------------------------- */
/*                            Normal CDF Function                          */
/* Return normcdf(dx).                                                     */
/* ----------------------------------------------------------------------- */
double normcdf(double mu, double sigma, double dx);

/* ----------------------------------------------------------------------- */
/*                               Erf Function                              */
/* Return erf(dx).                                                         */
/* ----------------------------------------------------------------------- */
double erf(double dx);